Nombremaille = 100;
dt = 0.5;
Longueur = 50;
dx=Longueur/Nombremaille
lambda=0.5;
R=zeros(Nombremaille,1);S=zeros(Nombremaille,1);
// Initialisation
// S(I)=1 et R(I)=0 (zone non infectee dans les 3/4 du domaine)
// S(I)=0.2 et R(I)=0.2 (zone infectee)
//
deff('s=f(t)','s=t-1-lambda*log(t)');
sigma=fsolve(lambda/2,f)
for I=Nombremaille/4:Nombremaille
	S(I)=1;
	R(I)=0;
end
for I=1:Nombremaille/4
	S(I)=sigma;
	R(I)=0.1;
end
//
// Matrice du laplacien
// (diffusion traitee de facon implicite)
//
A=[];
for I=2:Nombremaille-1,
	A(I,I)=-2;
	A(I-1,I)=1;
	A(I+1,I)=1;
end
A(1,1)=-1;
A(2,1)=1;
A(Nombremaille,Nombremaille)=-1;
A(Nombremaille-1,Nombremaille)=1;
AA = eye(Nombremaille,Nombremaille) - A*(dt/(dx^2));
B = inv(AA);
//
// Boucle de calcul
//
for J=1:1000,
//
// Etape reaction (equation diff ordinaire)
//
for I=1:Nombremaille,
	dS=-S(I)*R(I);
	S(I)=S(I)+dt*dS;
	R(I)=R(I)-dt*dS-dt*lambda*R(I);
end
//
// Etape diffusion
//
R= (B*R);
//
// Affichage de S et de R
//
xbasc();
plot2d([(1:Nombremaille)',(1:Nombremaille)'],[S,R],[1,2],'151','sain@infectes',[0,0,Nombremaille,1]);
end
