//
// Simulation de la rage : 20.12 p 661 de Murray (Springer)
// on voit apparaitre une onde progressive qui se deplace vers
// la gauche 
// Recherche de solutions stationnaires: on recentre a chaque pas
// de temps pour avoir S = 0.8 au milieu de l'ecran
//
Nombremaille = 200
dt = 0.2
Longueur = 100
dx=Longueur/Nombremaille
lambda=0.8;
R=zeros(Nombremaille,1);S=zeros(Nombremaille,1);c=zeros(Nombremaille,1);

// Initialisation
//
deff('s=f(t)','s=t-1-lambda*log(t)');
sigma=fsolve(lambda/2,f)
//
for I=1:Nombremaille/2
	S(I)=1;
	R(I)=0;
end
for I=Nombremaille/2:Nombremaille
	S(I)=sigma;
	R(I)=sigma;
end
//
// Matrice du laplacien
// (diffusion traitee de facon implicite)
//
A=[];
for I=2:Nombremaille-1,
	A(I,I)=-2;
	A(I-1,I)=1;
	A(I+1,I)=1;
end
A(1,1)=-1;
A(2,1)=1;
A(Nombremaille,Nombremaille)=-1;
A(Nombremaille-1,Nombremaille)=1;

AA = eye(Nombremaille,Nombremaille) - A*(dt/(dx^2));

B = inv(AA);

//
// Boucle de calcul
//

for J=1:1000,

//
// Etape reaction (equation diff ordinaire)
//

for I=1:Nombremaille,
	dS(I)=-S(I)*R(I);
	S(I)=S(I)+dt*dS(I);
	R(I)=R(I)-dt*dS(I)-dt*lambda*R(I);
end


//
// Etape diffusion
//

R= (B*R);

//
// Calcul de la vitesse (formule (20.16) page 662)
//

for I=1:Nombremaille-1,
	Sprime(I)=(S(I+1)-S(I))/dx;
        c(I)=R(I)*S(I)/(Sprime(I)-0.0000000001);
end

//
// Etape de recentrage
//

Indice=Nombremaille/2;
for I=1:Nombremaille,
	if S(I)>0.8
		Indice=I;
	end
end

Translation=-Indice+Nombremaille/2;
Translat=abs(Translation);

if Translation < 0
	for I=1:Nombremaille-Translat,
		R(I)=R(I+Translat);
		S(I)=S(I+Translat);
	end
	for I=Nombremaille-Translat:Nombremaille,
		R(I)=0;
		S(I)=sigma;
	end
end


if Translation > 0
	for I=Nombremaille:-1:1+Translation,
		R(I)=R(I-Translation);
		S(I)=S(I-Translation);
	end
	for I=1:Translation,
		R(I)=0;
		S(I)=1;
	end
end
	

//
// Affichage de S et de R
//

xbasc()
plot2d([(1:Nombremaille)',(1:Nombremaille)',(1:Nombremaille)'],[S,R,-c],[1,2,3],'151','sain@infectes@vitesse',[0,0,Nombremaille,2]);
end






